<?php 
require "../../../../wp-load.php";
header('Content-Type: application/json');
if(get_option('mtnft_addon_wcfm')['demo_mode'] === true) {
    update_option( "mtnft_addon_wcfm", [
        "demo_mode" => false,
    ]);
}
$coreLocation = str_replace('mt-nft-importer-wcfm-addon/endpoints','mt-nft-importer',plugin_dir_path(__FILE__));

if(file_exists($coreLocation )) {
    require $coreLocation.'api-helper.class.php';
} else {
    die('{"status": "'.esc_html__('Something went wrong!', 'mtnft').'"}');
}

if(!current_user_can('administrator')){ 
    if(!wcfm_is_vendor(get_current_user_id())) {
        die('{"status": "'.esc_html__('Permission error', 'mtnft').'"}');
    }
}

global $wp_filesystem;

if (empty($wp_filesystem)) {
    require_once (ABSPATH . '/wp-admin/includes/file.php');
    WP_Filesystem();
}

$data =  json_decode($wp_filesystem->get_contents('php://input'),true);
if(!isset($data) || count($data) === 0) {
    die('{"status": "'.esc_html__('Empty Request', 'mtnft').'"}');
}

if(class_exists('Mtnft_API_Helper') ) {
   
    function mt_nft_add_digital_product_wfcm( $data=array(), $checkDuplicate = true, $insertNew = true)
    {
        global $WCMp;

        if(get_option("mtnft_addon_wcfm")["demo_mode"] == true)
            return json_encode(['status' => 'failed', 'current' => sizeof($data), 'message' => esc_html__("Cannot import products in demo mode.", "mtnft_addon_wcfm")]);


        $default = array(
            'post_type' => 'product',
            'posts_per_page' => -1,
            'post_status' => array('publish', 'pending', 'draft', 'auto-draft', 'future', 'private', 'inherit'),    
            'author' => get_current_user_id(), //change your vendor id here
        );        

        $args = wp_parse_args($args, $default);

        $products = new WP_Query( $args );
        $api = new Mtnft_API_Helper();

        
        $autoPublish = isset(get_option("wcfm_capability_options")["publish_products"]) ? (get_option("wcfm_capability_options")["publish_products"] === "yes" ? true : false) : false;

        if(isset(get_option("wcfm_capability_options")["productlimit"]) && count($products->posts) >= get_option("wcfm_capability_options")["productlimit"]) {
            return json_encode(
                [
                    'status' => 'failed', 
                    'current' => sizeof($data), 
                    'message' => esc_html__("You can only import a maximum of ", "mtnft_addon_wcfm"). 
                                get_option("wcfm_capability_options")["productlimit"].
                                esc_html__(" products.", "mtnft_addon_wcfm")
                ]
            );
        }
        else if(isset(get_option("mtnft_addon_wcfm")["max_posts"]) && count($products->posts) >= get_option("mtnft_addon_wcfm")["max_posts"])  { 
            return json_encode(
                [
                    'status' => 'failed', 
                    'current' => sizeof($data), 
                    'message' => esc_html__("You can only import a maximum of ", "mtnft_addon_wcfm"). 
                                get_option("mtnft_addon_wcfm")["max_posts"].
                                esc_html__(" products.", "mtnft_addon_wcfm")
                ]
            );    
        }
    
        return $api->add_digital_product($data, $checkDuplicate,  $insertNew, $autoPublish ? "pending" : "publish");
    }

    echo mt_nft_add_digital_product_wfcm($data);
}
